#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <libgen.h>
#include <stdio.h>
#include <math.h>
#include <assert.h>
#include <limits.h>

#include "random.h"

#define VERBOSE(X) X
#define MAX(x,y)        ((x)>=(y)?(x):(y))
#define MAX_JOBS 501     /* max number of jobs */




typedef struct {
  long int number_jobs;                /* number of jobs in instance */
  long int release_date[MAX_JOBS];  /*there is no release date for these instances*/
  long int proc_time[MAX_JOBS];
  long int weight[MAX_JOBS];
  long int due_date[MAX_JOBS];
} instance_type;

instance_type instance;


typedef struct {
  long int  job_at_pos[MAX_JOBS];          /* Gives the job at a certain pos */
  long int  pos_of_job[MAX_JOBS];          /* Gives the position of a specific job */ 
  long int  completion_time_job[MAX_JOBS]; /* Gives C_j of job j */
  long int  start_time_job[MAX_JOBS];      /* Gives start time of job j */
  long int  tardiness_job[MAX_JOBS]; /* Gives T_j of job j */
  long int  value;                         /* Objective function value */
} sol_representation;

sol_representation sequence;



