#include <time.h>
#include "util.h"



extern double getCurrentTime();
void ls_swap_first( ) {};

void ls_interchange_first() {};


int main(int argc, char *argv[]) {

  int i,j;
  char  name_buf[100];           /* buffer for inputfilename */

  double end,start=getCurrentTime();

  if (argc>2)
    {
      set_seed(atoi(argv[2]));
      printf("seed set to: %f\n",atof(argv[2]));
    }
  else
    {
      double s=time(NULL);
      set_seed(s);
      printf("seed set to: %f\n",s);
    }

  strncpy( name_buf, argv[1], strlen( argv[1] ) );
  read_problem_size(name_buf);
  read_instances(name_buf);

  construct_sequence_canonical(i);
  //construct_sequence_random( );
  printf("%d\n",sequence.value);

  int local_search_flag =  2;

  switch ( local_search_flag ) {
  case 1:
    ls_swap_first( );
    break;
  case 2: 
    ls_interchange_first( );
    break;
  case 3: 
    ls_interchange_first( );
    ls_swap_first( );
    break;
  case 4: 
    ls_swap_first( );
    ls_interchange_first( );
    break;
  default:
    printf("Local search not set\n");
  }

  end=getCurrentTime();
  printf("elapsed time %.2f\n",end-start);

  return(0);
  
}
